﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using System.ComponentModel;
using System.Collections.ObjectModel;
using System.Linq.Expressions;
using IdeaBlade.EntityModel;
using System.Collections;
using IdeaBlade.Linq;
using System.Reflection;

namespace SilverlightConsole {

  public class MainDemo {
    ResultsReporter _resultsReporter;

    public MainDemo(ResultsReporter callbackMethod) {
      Utility.InitializeDemo(_nameDemo, ref callbackMethod, ref _resultsReporter, ref _localOutput);
    }

    public async void BasicQuerySyntaxQuery() {
      _localOutput.Append(String.Format("[{0}] Started...\n", _nameBasicQuerySyntaxQuery));

      Utility.ResetEntityManager(_em1);
      await _em1.ConnectAsync();
      var customersQuery = _em1.Customers
        .Where(c => c.ContactTitle == "Sales Representative")
        .OrderBy(c => c.CompanyName);

      var results = await _em1.ExecuteQueryAsync<Customer>(customersQuery);
      _localOutput.Append(string.Format("[{0}] Retrieved {1} customers\n", _nameBasicQuerySyntaxQuery, results.Count()));
      Utility.FlushOutputBuffer(_localOutput, _resultsReporter);
    }

    #region Private Fields

    const string _nameDemo = "MainDemo (MDM)";
    const string _nameBasicQuerySyntaxQuery = "MDM:BasicQuerySyntaxQuery";
    const string _nameQueryCacheDataSynchronously = "MDM:QueryCacheDataSynchronously";
    const string _nameGetFirstCustomer = "MDM:GetFirstCustomer";

    NorthwindIBModelManager _em1 = new NorthwindIBModelManager(shouldConnect: false);
    StringBuilder _localOutput;

    #endregion Private Fields

  }
}